<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="98px">
      <el-form-item label="阀井名称" prop="valveWellName">
        <el-input v-model="queryParams.valveWellName" placeholder="请输入阀井名称" clearable size="small"/>
      </el-form-item>
      <el-form-item label="队伍" >
        <el-select v-model="queryParams.ranks" clearable placeholder="请选择队伍" @change="getUsers" :disabled="postName.indexOf('xx') > -1&&postName!='xxallrank'">
          <el-option
            v-for="item in postOptions"
            :key="item.postId"
            :label="item.postName"
            :value="item.postId"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="上传人" prop="createBy">
        <el-select v-model="queryParams.createBy" filterable placeholder="请选择上传人" clearable size="small">
          <el-option v-for="item in workerListSelect"
                     :key="item.id"
                     :label="item.name"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="位置" prop="positionId">
        <el-select v-model="queryParams.positionId" placeholder="请选择位置" filterable clearable size="small"
                   @keyup.enter.native="handleQuery" style="width: 100%" >
          <el-option
            v-for="item in listValveWellPositionList"
            :key="item.id"
            :label="item.position"
            :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="发现问题" prop="discoverProblems">
        <el-select v-model="queryParams.discoverProblems" placeholder="请选择发现问题" clearable size="small">
          <el-option
            v-for="dict in dict.type.find_problem"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="审核状态">
        <el-select v-model="queryParams.processStatus" placeholder="请选择审核状态" clearable size="small">
          <el-option
            v-for="dict in dict.type.process_status"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="上传时间范围" prop="createTimes">
        <el-date-picker
          v-model="queryParams.createTimes"
          type="datetimerange"
          :picker-options="pickerOptions"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          align="right">
        </el-date-picker>
      </el-form-item>
<!--      <el-form-item label="发现时间" prop="discoverTime">-->
<!--        <el-date-picker clearable size="small"-->
<!--                        v-model="queryParams.discoverTime"-->
<!--                        type="date"-->
<!--                        value-format="yyyy-MM-dd"-->
<!--                        placeholder="选择发现时间">-->
<!--        </el-date-picker>-->
<!--      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['gas:valveWellInspection:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['gas:valveWellInspection:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['gas:valveWellInspection:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['gas:valveWellInspection:export']"
        >导出
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-search"
          size="mini"
          :disabled="multiple"
          @click="openshShow(null,true)"
          v-hasPermi="['gas:regulatingBoxMaintenance:remove']"
        >批量审核
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-s-claim"
          size="mini"
          :disabled="multiple"
          @click="chushiBatch"
          v-if="['deputyDirector','director','admin'].includes(this.$store.state.user.postName)"
        >一键审核通过
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-dialog title="审核记录" :visible.sync="reviewListShow" width="800px" append-to-body>
      <el-table
        :data="reviewList"
        style="width: 100%"
        border
        :header-cell-style="{'text-align':'center'}"
        height="500">
        <el-table-column label="历史审核记录">
          <el-table-column
            prop="createName"
            label="审核人"
            width="80">
          </el-table-column>
          <el-table-column
            prop="userPost"
            label="岗位"
            width="65">
            <template slot-scope="scope">
              <span v-if="scope.row.userPost == 'admin'">管理员</span>
              <span v-if="scope.row.userPost == 'deputyDirector'">副处长</span>
              <span v-if="scope.row.userPost == 'director'">处长</span>
              <span v-if="scope.row.userPost.indexOf('xx')>-1">队长</span>
            </template>
          </el-table-column>
          <el-table-column
            prop="processStatus"
            label="审核状态"
            width="75">
            <template slot-scope="scope">
              {{ scope.row.processStatus == '0' ? '通过' : '拒绝' }}
            </template>
          </el-table-column>
          <el-table-column
            prop="createTime"
            label="审核时间"
            width="155">
          </el-table-column>
          <el-table-column
            prop="processComments"
            label="审核意见"
            width="384">
          </el-table-column>
        </el-table-column>
      </el-table>
      <div slot="footer" class="dialog-footer">
        <el-button @click="reviewListShow = false">关 闭</el-button>
      </div>
    </el-dialog>

    <el-table v-loading="loading" :data="valveWellInspectionList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="" align="center" prop="id" v-if="false"/>
      <el-table-column label="序号" width="70">
        <template slot-scope="scope">
          {{(queryParams.pageNum-1)*queryParams.pageSize+scope.$index+1}}
        </template>
      </el-table-column>
      <el-table-column label="阀井名称" align="center" prop="valveWellName"/>
      <el-table-column label="阀井位置" align="center" prop="positionName"/>
      <el-table-column label="发现问题" align="center" prop="discoverProblems">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.find_problem" :value="scope.row.discoverProblems"/>
        </template>
      </el-table-column>
      <el-table-column label="上传时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d} {h}:{i}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="上传人" align="center" prop="createByName" width="180">
      </el-table-column>
      <el-table-column label="审核状态" align="center" prop="processStatus">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.process_status" :value="scope.row.processStatus"
                    v-if="scope.row.processStatus != null"/>
          <span v-else>未审核</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark"/>
      <el-table-column label="照片" align="center">
        <template slot-scope="scope">
          <el-image
            style="width: 50px; height: 50px"
            :src="scope.row.photoList[0]"
            :preview-src-list="scope.row.photoList">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleUpdate(scope.row,true)"
            v-hasPermi="['gas:regulatingBoxMaintenance:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row,false)"
            v-hasPermi="['gas:valveWellInspection:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="process(scope.row)"
            v-if="btnShow(scope.row)"
            v-hasPermi="['gas:regulatingBoxMaintenance:edit']"
          >审核
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="reviewListOpen(scope.row)"
          >审核记录
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['gas:valveWellInspection:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <el-dialog
      title="审核"
      :visible.sync="dialogVisible"
      width="30%">
      <el-form ref="shFrom" :model="shFrom" label-width="80px">
        <el-form-item label="审核状态">
          <el-select v-model="shFrom.processStatus" placeholder="请选择审核状态" clearable size="small"  @change="$forceUpdate()" >
            <el-option
              v-for="dict in dictList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="备注">
          <el-input type="textarea" v-model="shFrom.processComments"></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
    <el-button @click="dialogVisible = false">取 消</el-button>
    <el-button type="primary" @click="upprocess">确 定</el-button>
  </span>
    </el-dialog>
    <!-- 添加或修改阀井巡查对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px" :disabled="isDisabled">
        <el-form-item label="阀井名称" prop="position">
          <el-select v-model="form.positionId" placeholder="请选择阀井名称" filterable clearable size="small"
                     @change="getPositionName" style="width: 100%">
            <el-option
              v-for="item in listValveWellPositionList"
              :key="item.id"
              :label="item.valveWellName"
              :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="位置" prop="position">
          <el-input v-model="weizhi" placeholder="位置" disabled/>
        </el-form-item>
        <el-form-item label="发现问题" prop="discoverProblems">
          <el-select v-model="form.discoverProblems" placeholder="请选择发现问题" clearable size="small" style="width: 100%" @change="checkRemark">
            <el-option
              v-for="dict in dict.type.find_problem"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="阀井情况" prop="remark" :rules="form.discoverProblems == '0' ? [{ required: true, message: '请输入阀井情况', trigger: 'blur' }] : []">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入阀井情况" @blur="checkRemark"/>
        </el-form-item>
        <el-col :span="24">
          <el-form-item label="照片" prop="photoList">
            <imageUpload v-model="form.photoList" :disabled="disabled"/>
          </el-form-item>
        </el-col>
        <el-form-item label="审核状态" v-show="isDisabled && form.processStatus!=null">
          <el-select v-model="form.processStatus" placeholder="请选择审核状态" clearable size="small" @change="$forceUpdate">
            <el-option
              v-for="dict in dict.type.process_status"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="审核备注" v-show="isDisabled && form.processStatus!=null">
          <el-input type="textarea" v-model="form.processComments" placeholder=""/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listValveWellInspection,
  getValveWellInspection,
  delValveWellInspection,
  addValveWellInspection,
  updateValveWellInspection,
  batchReview
} from "@/api/gas/valveWellInspection";
import {listValveWellPosition} from "@/api/gas/valveWellPosition";
import Cookies from "js-cookie";
import {listPostAll} from "@/api/system/post";
import {getReviewList} from "@/api/gas/valveWellInspection";
import {getWorker} from "@/api/gas/user";

export default {
  name: "ValveWellInspection",
  dicts: ['find_problem','process_status'],
  data() {
    return {
      dictList:[{label:'通过',value:'0'},{label:'不通过',value:'1'}],
      //审核记录
      reviewListShow: false,
      reviewList: [],
      shFrom: {
        id: '',
        uids: [],
        processStatus: '',
        processComments: "",
        postNameArias: null,
      },
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },
      isDisabled: false,
      dialogVisible: false,
      // 按钮loading
      buttonLoading: false,
      disabled: false,
      // 岗位选项
      postOptions: [],
      postName:Cookies.get("postName"),
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      weizhi: '',
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 阀井巡查表格数据
      valveWellInspectionList: [],
      workerList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        positionId: undefined,
        discoverProblems: undefined,
        discoverTime: undefined,
        createTimes:[],
        processStatus: undefined,
        postNameArias:this.$store.state.user.postName,
        ranks:(Cookies.get("postName").indexOf('xx') > -1 ? parseInt(Cookies.get("postId")) : undefined),
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        id: [
          {required: true, message: "不能为空", trigger: "blur"}
        ],
        positionId: [
          {required: true, message: "位置id不能为空", trigger: "blur"}
        ],
        discoverProblems: [
          {required: true, message: "发现问题不能为空", trigger: "blur"}
        ],
        remark: [
          {required: true, message: "阀井情况不能为空", trigger: "blur"}
        ],
      },
      workerListSelect:[],
      listValveWellPositionList: []
    };
  },
  created() {
    this.listValveWellPosition();
    this.getPostList();
    this.getList();
    // this.getWorkerList();
  },
  mounted() {
    setTimeout(
      this.getUsers(parseInt(Cookies.get("postId")))
      ,1000)
  },
  methods: {
    btnShow(row){
      let b = false;
      if (row.flag==true){
        b = true;
      }
      return b;
    },
    reviewListOpen(row){
      this.reviewList = [];
      this.reviewListShow=true;
      getReviewList({emrId: row.id}).then(res=>this.reviewList = res.rows);
    },
    checkRemark(value){
      if (value=='0'){
        this.$nextTick(() => {
          this.$refs['form'].validateField('remark');
        });
      }else {
        this.$refs['form'].clearValidate('remark');
      }
    },
    getUsers(value){
      if (!value) return;
      getWorker({ranks:value}).then(response => {
        this.workerListSelect = response.data;
      });
    },
    getWorkerList(ranks) {
      let data = null
      if(ranks){
        data = {
          ranks:ranks
        }
      }
      getWorker(data).then(req => {
        this.workerList = req.data
      })
    },
    getPostList(){
      listPostAll({remark:'ranks'}).then(response => {
        this.postOptions = response.data;
      });
    },
    getPositionName() {
      if (this.form.positionId === '') {
        this.weizhi = ''
        return
      }
      this.weizhi = this.listValveWellPositionList.filter(item => item.id === this.form.positionId)[0].position
    },
    listValveWellPosition() {
      listValveWellPosition().then(res => {
        this.listValveWellPositionList = res.rows
      })
    },
    /** 查询阀井巡查列表 */
    getList() {
      this.loading = true;
      listValveWellInspection(this.queryParams).then(response => {
        this.valveWellInspectionList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        positionId: undefined,
        discoverProblems: undefined,
        discoverTime: undefined,
        remark: undefined,
        delFlag: undefined,
        createBy: undefined,
        photoList: [],
        createTime: undefined,
        updateBy: undefined,
        updateTime: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryParams.createTimes=[]
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.disabled = false
      this.weizhi = ''
      this.title = "添加阀井巡查";
    },
    upprocess(){
      const postNameArias = this.$store.state.user.postName;
      this.shFrom.postNameArias = postNameArias
      if (this.shFrom.processStatus == undefined || this.shFrom.processStatus == ''){
        this.$message.warning("请选择审核状态")
      }
      if (this.shFrom.id != null) {
        updateValveWellInspection(this.shFrom).then(response => {
          this.$modal.msgSuccess("审核成功");
          this.getList();
        }).finally(() => {
          this.dialogVisible = false;
        });
      }else if (this.shFrom.uids.length > 0) {
        batchReview(this.shFrom).then(response => {
          this.$modal.msgSuccess("审核成功");
          this.dialogVisible = false;
          this.getList();
        }).finally(() => {
          this.buttonLoading = false;
        });
      }
    },
    chushiBatch(){
      if (this.ids.length > 0) {
        let chushiForm = {uids:[],processStatus:null,processComments:null,postNameArias:null}
        chushiForm.processStatus = '0';
        chushiForm.processComments = '一键审核通过';
        chushiForm.uids = this.ids;
        chushiForm.postNameArias = this.$store.state.user.postName;
        console.log(chushiForm)
        batchReview(chushiForm).then(response => {
          if (response.code===200) {
            this.$modal.msgSuccess("审核成功");
          }
          this.getList();
        })
      }
    },
    openshShow(data, isBatch) {
      this.shFrom = {
        id: undefined,
        uids: [],
        processStatus: undefined,
        processComments: undefined,
      }
      if (isBatch)
        this.shFrom.uids = this.ids
      else
        this.shFrom.uids = [data.id]
      this.dialogVisible = true
    },
    process(data) {
      this.shFrom.id = undefined
      this.shFrom.uids = [data.id];
      this.shFrom.processStatus = '';
      this.shFrom.processComments = '';
      this.dialogVisible = true;
    },
    /** 修改按钮操作 */
    handleUpdate(row,disabled) {
      this.loading = true;
      this.isDisabled = disabled;
      this.reset();
      const id = row.id || this.ids
      getValveWellInspection(id).then(response => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.getPositionName()
        this.title = "修改阀井巡查";
        this.disabled = false
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            if (typeof this.form.photoList === 'string') {
              this.form.photoList = this.form.photoList.split(',')
            }
            updateValveWellInspection(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            if (this.form.photoList.length > 0)
              this.form.photoList = this.form.photoList.split(',')
            addValveWellInspection(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除阀井巡查编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delValveWellInspection(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.$download.excel('/gas/valveWellInspection/export', this.queryParams);
    }
  }
};
</script>
